! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!*****************************************************************
!
!
!****************************************************************
module statistics_mod
    use param
    use cal
    use dal
 
  use oal
  use caloaldefs
  

  
  use errorHandling
    use sasdal
  
    use omnumerics_mod 
    use omallocation_mod
 

type MWWData

    integer :: no
    real(single) :: rank
    real(single) :: value     


end type MWWData


contains


!**********************************************************************
!
!
!*********************************************************************
real(single) function Percentile(nData, data, frac)
    integer, intent(in) :: ndata
    real(single) :: data(:)
    real(single), intent(in) :: frac

    real(single), pointer :: temp(:)=>null()
    integer :: k

    if(ndata .eq. 0 ) then
        Percentile = 0.0
        return

    end if

    temp => allocateSingle(1, nData, "temp")
    temp = data(1 : ndata)


    call heapSort(temp, nData)

    k = int(frac * real(ndata) + 0.00001)
    k = max(1, k)

    Percentile = temp(k)
    deallocate(temp)
    nullify(temp)
    

end function percentile    





!*************************************************************
!
!************************************************************


!real(single) function Percentile( data, n, fraction)
!    real(single) :: data(:)
!    integer, intent(in) :: n
!    real(single), intent(in) :: fraction
!    integer :: k

!    k = nint( real(n) * fraction)

!    if(k < 1) then
!        Percentile = 0.0
!    else
!        Percentile = data(k)
!    end if

!end function percentile












end module statistics_mod


























